#include <iostream>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    long long n,h,b=1,po=0,sum=0,sum1=0;

    cin >> h;
    cin >> n;

    int vodopad[h+10][n+10];
    int vodauvodopadu[h+10][n+10]={0};

    for(int i=0; i<=h; i++)
    {
        for(int j=1; j<=n; j++)
        {
            if(i==0)
            {
                vodauvodopadu[i][j]=1;
            }
            else if(i!=0 && i!=h+1)
            {
                cin >> vodopad[i][j];
            }
        }
    }

    for(int i=1; i<=h; i++)
    {
        po=0;
        b=1;
        sum=sum1=0;

        for(int j=1; j<=n; j++)
        {
            if(vodopad[i][j]==0)
            {
                if(j==1 || b==0)
                {
                    sum1+=vodauvodopadu[i-1][j];
                    b=0;
                }
                else
                {
                    if(j==n)
                    {
                        sum+=vodauvodopadu[i-1][j];
                        vodauvodopadu[i][po]+=sum;
                        sum=0;
                    }
                    else
                    {
                        sum+=vodauvodopadu[i-1][j];
                    }
                }
            }
            else
            {
                vodauvodopadu[i][j]+=vodauvodopadu[i-1][j];

                if(sum>0)
                {
                    vodauvodopadu[i][po]+=(int)(sum/2)+(sum%2==0 ? 0:(i%2==1 ? 1:0));
                    vodauvodopadu[i][j]+=(int)(sum/2)+(sum%2==0 ? 0:(i%2==0 ? 1:0));
                    sum=0;
                }

                if(sum1>0)
                {
                    vodauvodopadu[i][j]+=sum1;
                    sum1=0;
                }

                po=j;
                b=1;
            }
        }
    }

    for(int j=1; j<=n; j++)
    {
        cout << vodauvodopadu[h][j] << " ";
    }
    return 0;
}